﻿// // ******************************************************************
// //       /\ /|       @File         Enums.cs
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-22
// //      /  \\        @Modified      2024-1-26
// //    *(__\_\
// // ******************************************************************
namespace TekWaveformSampling;

public class Enums
{
    public enum USBSpeed
    {
        LowSpeed = 0,
        FullSpeed = 1,
        HighSpeed = 2,
    };
    public enum SignType
    {
        SingleEnded,
        Diff
    };
    public enum DataBitWidth
    {
        DataBitWidth_5Bit = 5,
        DataBitWidth_6Bit,
        DataBitWidth_7Bit,
        DataBitWidth_8Bit
    }

    public enum StopBit
    {
        StopBit_2bit,
        StopBit_1bit
    }
    public enum RS232DecodeEventType
    {
        None,
        Start,
        Data,
        Parity
    }
    public enum EventInfoTitles
    {
        UNKNOW,
        INDEX,
        START_TIME,
        SYNC,
        SOF,
        SETUP,
        PID,
        DATA0,
        DATA1,
        DATA2,
        MDATA,
        ADDR,
        ACK,
        //IN,关键字
        TIN,
        //OUT,关键字
        TOUT,
        NAK,
        STALL,
        NYET,
        FNUM,
        CRC5,
        CRC16,
        EOP,
        //ERROR, 关键字
        ERR,
    };
}
