﻿// // ******************************************************************
// //       /\ /|       @File         Helper.cs
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-17
// //      /  \\        @Modified      2024-1-26
// //    *(__\_\
// // ******************************************************************
using System.Globalization;
using System.Runtime.InteropServices;
using ComModel;
using CsvHelper;
using TekWaveformSampling.Model;

namespace TekWaveformSampling;

public class Helper
{
    const int READ_LENGTH_MAX = 10 * 1024 * 1024;
    public static TekWaveformData ReadTekCsvFile(string filePath)
    {
        //filePath = "232_000.csv";
        using (StreamReader? reader = new(filePath))
        {
            int i = 0, m = 0;
            reader.Peek();
            string? dataStr;
            TekWaveformData tekWaveformData = new();
            do
            {

                dataStr = reader.ReadLine()?.Trim();
                if (string.IsNullOrWhiteSpace(dataStr))
                {
                    continue;
                }
                if (dataStr.Contains("Model"))
                {
                    tekWaveformData.Model = dataStr.Replace("Model,", "");
                }
                else if (dataStr.Contains("Waveform Type"))
                {
                    tekWaveformData.WaveformType = dataStr.Replace("Waveform Type,", "");
                }
                else if (dataStr.Contains("Sample Interval"))
                {
                    tekWaveformData.SampleInterval = double.Parse(dataStr.Replace("Sample Interval,", ""));
                }
            }

            while (reader.Peek() > 0 && dataStr != "TIME,REF1" && dataStr != "TIME,CH1" && dataStr != "TIME,CH2");

            using (CsvReader? csv = new(reader, CultureInfo.InvariantCulture))
            {
                csv.Read();
                tekWaveformData.WaveformDatas = csv.GetRecords<WaveformData>().ToList();
                return tekWaveformData;
            }
        }
    }


}
