﻿// // ******************************************************************
// //       /\ /|       @File         struct RS232DecodeResultStruct.cs
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-26
// //      /  \\        @Modified      2024-1-26
// //    *(__\_\
// // ******************************************************************
using System.Runtime.InteropServices;

namespace TekWaveformSampling.Model;

[StructLayout(LayoutKind.Sequential)]
internal struct RS232DecodeResultUnitStruct
{
    public Int64 StartIndex;
    public Int64 Length;
    public IntPtr Datas;
    public Int64 DatasCount;
    public bool IsEventInfo;
    public RS232DecodeResultUnitStruct()
    {
        StartIndex = -1;
        Length = -1;
        DatasCount = 0;
        Datas = IntPtr.Zero;
        IsEventInfo = false;
    }

}
[StructLayout(LayoutKind.Explicit, Size = 32)]
internal struct RS232DecodeEventUintStruct
{
    [FieldOffset(0)] public Int64 StartIndex;
    [FieldOffset(8)] public Int64 Length;
    [FieldOffset(16)] public byte Data;

    [FieldOffset(24)] public Enums.RS232DecodeEventType EventType;

}
[StructLayout(LayoutKind.Explicit, Size = 56)]
internal struct RS232DecodeEventStruct
{
    [FieldOffset(0)] public Int64 EventIndex = -1;
    [FieldOffset(8)] public Int64 StartIndex = 0;
    [FieldOffset(16)] public Int64 EndIndex = 0;
    [FieldOffset(24)] public IntPtr Name; //string ptr  

    [FieldOffset(32)] public byte ParityResult; //string ptr  
    [FieldOffset(40)] public IntPtr EventDatas; //List<RS232DecodeEventUint> ptr  
    [FieldOffset(48)] public Int64 EventDatasCount;
    public RS232DecodeEventStruct()
    {
        Name = IntPtr.Zero;
        EventDatas = IntPtr.Zero;
    }

    // public bool Equals(RS232DecodeEvent decodeEvent)
    // {
    //     if (decodeEvent.EventDatas.Count() != decodeEvent.EventDatas.Count())
    //     {
    //         return false;
    //     }
    //     int size = decodeEvent.EventDatas.Count();
    //     for (int i = 0; i < size; i++)
    //     {
    //         if (!decodeEvent.EventDatas[i].Equals(EventDatas[i]))
    //         {
    //             return false;
    //         }
    //     }
    //     return true;
    // }
}
//[StructLayout(LayoutKind.Explicit)]
//public struct RS232DecodeResultStruct
//{

//    [FieldOffset(0)] public bool ResultValid;
//    [FieldOffset(8)] public bool DecodeResultNeedUpdate;
//    [FieldOffset(16)] public bool DecodeEventNeedUpdate;
//    // public List<RS232DecodeResultUnit> DecodeResultUnits;
//    // public List<RS232DecodeEvent> DecodeEvents;
//    [FieldOffset(24)] public IntPtr DecodeResultUnits;
//    [FieldOffset(32)] public IntPtr DecodeEvents;
//    [FieldOffset(40)] public UInt64 DecodeResultCount;
//    [FieldOffset(48)] public UInt64 DecodeEventCount;

//}

//[StructLayout(LayoutKind.Explicit)]
//public struct RS232DecodeResultStruct
//{

//    [FieldOffset(0)] public bool DecodeResultNeedUpdate;
//    [FieldOffset(8)] public bool DecodeEventNeedUpdate;
//    [FieldOffset(16)] public IntPtr DecodeResultUnits;
//    // public List<RS232DecodeResultUnit> DecodeResultUnits;
//    // public List<RS232DecodeEvent> DecodeEvents;
//    [FieldOffset(24)] public IntPtr DecodeEvents;
//    [FieldOffset(32)] public UInt64 DecodeResultCount;
//    [FieldOffset(40)] public UInt64 DecodeEventCount;


//}

[StructLayout(LayoutKind.Sequential)]
public struct RS232DecodeResultStruct
{
    public bool DecodeResultNeedUpdate;
    public bool DecodeEventNeedUpdate;

    public IntPtr DecodeResultUnits;
    public IntPtr DecodeEvents;
    public UInt64 DecodeResultCount;
    public UInt64 DecodeEventCount;

}
