﻿// // ******************************************************************
// //       /\ /|       @File         TekWaveformData.cs
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-17
// //      /  \\        @Modified      2024-1-26
// //    *(__\_\
// // ******************************************************************
using CsvHelper.Configuration.Attributes;

namespace TekWaveformSampling;

public class WaveformData
{
    [Index(0)] public double Time { get; set; }

    [Index(1)] public double Voltage { get; set; }
}
public class TekWaveformData
{

    public string? Model { get; set; }
    public string? WaveformType { get; set; }

    public double SampleInterval { get; set; }

    public double SampleRateMHz
    {
        get
        {
            return SampleInterval <= 0 ? 0 : 1 / SampleInterval / 1e6;
        }
    }
    public List<WaveformData>? WaveformDatas { get; set; }
}
